; ### Marlin K-Factor Calibration Pattern ###
; -------------------------------------------
; Generated from https://marlinfw.org/tools/lin_advance/k-factor.html
; Ref: https://marlinfw.org/docs/features/lin_advance.html
; Ref: https://help.prusa3d.com/en/article/linear-advance_2252/
;
; Printer: PrusaMK3S
; Filament: PETG
; Created: Sat May 09 2020 20:56:51 GMT-0700 (Pacific Daylight Time)
;
; Settings Printer:
; Filament Diameter = 1.75 mm
; Nozzle Diameter = 0.4 mm
; Nozzle Temperature = 250 °C
; Bed Temperature = 90 °C
; Retraction Distance = 0.8 mm
; Layer Height = 0.2 mm
; Z-axis Offset = 0 mm
;
; Settings Print Bed:
; Bed Shape = Rect
; Bed Size X = 250 mm
; Bed Size Y = 210 mm
; Origin Bed Center = false
;
; Settings Speed:
; Slow Printing Speed = 1200 mm/min
; Fast Printing Speed = 4200 mm/min
; Movement Speed = 7200 mm/min
; Retract Speed = 3600 mm/min
; Printing Acceleration = 1000 mm/s^2
; Jerk X-axis = 8
; Jerk Y-axis = 8
; Jerk Z-axis = 0.4
; Jerk Extruder = 4.5
;
; Settings Pattern:
; Linear Advance Version = 1.5
; Starting Value Factor = 0
; Ending Value Factor = 0.16
; Factor Stepping = 0.02
; Test Line Spacing = 5 mm
; Test Line Length Slow = 20 mm
; Test Line Length Fast = 60 mm
; Print Pattern = Standard
; Print Frame = false
; Number Lines = false
; Print Size X = 100 mm
; Print Size Y = 65 mm
; Print Rotation = 0 degree
;
; Settings Advance:
; Nozzle / Line Ratio = 1.1
; Bed leveling = 0
; Use FWRETRACT = false
; Extrusion Multiplier = 1
; Prime Nozzle = false
; Prime Extrusion Multiplier = 2.5
; Prime Speed = 1800
; Dwell Time = 2 s
;
; prepare printing
;
M107
G90 ; absolute coordinate mode
M83 ; extruder relative mode
M140 S90 ; set bed temp
M190 S90 ; wait for bed temp
M104 S250 ; set initial temp
G28 W ; home all without mesh bed level
M860 S35 ; wait until PINDA is >= 35C
M109 S250 ; wait for extruder temp
G80 ; mesh bed leveling
G81 ; print mesh results
G1 Y-3.0 F1000.0 ; go outside print area
G92 E0.0
G1 X60.0 E22.0  F1000.0 ; intro line
G1 X100.0 E8.0  F1000.0 ; intro line
G92 E0.0

G21 ; Millimeter units
G90 ; Absolute XYZ
M83 ; Relative E
M204 P1000 ; Acceleration
M205 X8 ; X Jerk
M205 Y8 ; Y Jerk
M205 Z0.4 ; Z Jerk
M205 E4.5 ; E Jerk
G92 E0 ; Reset extruder distance
G1 Z0.2 F1200 ; Move to layer height
G1 E-0.8 F3600 ; retract

;
; start the Test pattern
;
G4 P2000 ; Pause (dwell) for 2 seconds
G1 X75 Y72.5 F7200 ; move to start
M900 K0 ; set K-factor
M117 K0 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y72.5 E0.7317 F1200 ; print line
G1 X155 Y72.5 E2.1952 F4200 ; print line
G1 X175 Y72.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y77.5 F7200 ; move to start
M900 K0.02 ; set K-factor
M117 K0.02 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y77.5 E0.7317 F1200 ; print line
G1 X155 Y77.5 E2.1952 F4200 ; print line
G1 X175 Y77.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y82.5 F7200 ; move to start
M900 K0.04 ; set K-factor
M117 K0.04 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y82.5 E0.7317 F1200 ; print line
G1 X155 Y82.5 E2.1952 F4200 ; print line
G1 X175 Y82.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y87.5 F7200 ; move to start
M900 K0.06 ; set K-factor
M117 K0.06 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y87.5 E0.7317 F1200 ; print line
G1 X155 Y87.5 E2.1952 F4200 ; print line
G1 X175 Y87.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y92.5 F7200 ; move to start
M900 K0.08 ; set K-factor
M117 K0.08 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y92.5 E0.7317 F1200 ; print line
G1 X155 Y92.5 E2.1952 F4200 ; print line
G1 X175 Y92.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y97.5 F7200 ; move to start
M900 K0.1 ; set K-factor
M117 K0.1 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y97.5 E0.7317 F1200 ; print line
G1 X155 Y97.5 E2.1952 F4200 ; print line
G1 X175 Y97.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y102.5 F7200 ; move to start
M900 K0.12 ; set K-factor
M117 K0.12 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y102.5 E0.7317 F1200 ; print line
G1 X155 Y102.5 E2.1952 F4200 ; print line
G1 X175 Y102.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y107.5 F7200 ; move to start
M900 K0.14 ; set K-factor
M117 K0.14 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y107.5 E0.7317 F1200 ; print line
G1 X155 Y107.5 E2.1952 F4200 ; print line
G1 X175 Y107.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X75 Y112.5 F7200 ; move to start
M900 K0.16 ; set K-factor
M117 K0.16 ; 
G1 E0.8 F3600 ; un-retract
G1 X95 Y112.5 E0.7317 F1200 ; print line
G1 X155 Y112.5 E2.1952 F4200 ; print line
G1 X175 Y112.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
;
; Mark the test area for reference
M117 K0
M900 K0 ; Set K-factor 0
G1 X95 Y117.5 F7200 ; move to start
G1 E0.8 F3600 ; un-retract
G1 X95 Y137.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 X155 Y117.5 F7200 ; move to start
G1 E0.8 F3600 ; un-retract
G1 X155 Y137.5 E0.7317 F1200 ; print line
G1 E-0.8 F3600 ; retract
G1 Z0.3 F1200 ; zHop
;
; FINISH
;

G4 ; wait
M221 S100
M104 S0 ; turn off extruder
M140 S0 ; turn off heatbed
G1 Z30 E-20 ; Move print head up and retract
G0 X0 Y210 F6000; home axis
M84 ; disable motors
M104 S0 ; turn off extruder
M107 ; turn off fan